#ifndef GPDEVICENSUPPORT_H
#define GPDEVICENSUPPORT_H

#include <gutenprint/gutenprint.h>
#include "gp_cppsupport/gprintersettings.h"
#include "imagesource/devicencolorant.h"
#include "imagesource/imagesource_devicen_preview.h"

class GPColorant;

// List header subclass - not strictly necessary,
// but avoids the need for untidy casts elsewhere.
class GPColorantList : public DeviceNColorantList
{
	public:
	GPColorantList(stp_vars_t *vars);
	GPColorantList(GPrinterSettings *gp);
	virtual ~GPColorantList();
	virtual GPColorant *First();
	virtual char *GetEnabledColorants();
	virtual void SetEnabledColorants(const char *col);
	protected:
	void BuildList(stp_vars_t *vars);
	void BuildList_Raw(stp_vars_t *vars);
};


// Colorant subclass - tracks the enabled/disabled
// status of each colorant.

class GPColorant : public DeviceNColorant
{
	public:
	GPColorant(DeviceNColorantList &header,const char *name);
	GPColorant(DeviceNColorantList &header);
	virtual ~GPColorant();
	virtual GPColorant *NextColorant();
	virtual GPColorant *PrevColorant();
	void Enable();
	void Disable();
	bool GetEnabled();
	protected:
	bool enabled;
};

int GetPrinterColorantCount(stp_vars_t *vars);

// GPColorantList *GetPrinterColorantList(stp_vars_t *vars);
// ISDeviceN_Colorant_Preview *GetPrinterColorants(stp_vars_t *vars);

#endif

