#include <iostream>

#include "imagesource/imagesource_scaledensity.h"
#include "imagesource/imagesource_gamma.h"

#include "linearization.h"

using namespace std;

ConfigTemplate Linearization::Template[]=
{
	ConfigTemplate("BaseDensity",float(1.0)),
	ConfigTemplate("BaseGamma",float(1.0)),
	ConfigTemplate()
};


Linearization::Linearization(ConfigFile *file) : ConfigDB(Template)
{
	new ConfigDBHandler(file,"[Linearization]",this);
}


Linearization::~Linearization()
{

}


ImageSource *Linearization::Apply(ImageSource *source)
{
	source=new ImageSource_Gamma(source,FindFloat("BaseGamma"));

	ISDeviceNValue density(source->samplesperpixel,ISDataType(FindFloat("BaseDensity")*IS_SAMPLEMAX));
	source=new ImageSource_ScaleDensity(source,density);

	return(source);
}

