#include <iostream>

#include <gtk/gtkstock.h>
#include <gtk/gtkmain.h>

#include "menu_file.h"
#include "lincore.h"
#include "projectgui.h"
#include "support/generaldialogs.h"

#include "dialogs.h"

#include "config.h"
#include "gettext.h"
#define _(x) gettext(x)
#define N_(x) gettext_noop(x)

using namespace std;


#if 0
static void savegeometry(pp_MainWindow *mw)
{
	gint x,y,w,h;
	gtk_window_get_position(GTK_WINDOW(mw),&x,&y);
	gtk_window_get_size(GTK_WINDOW(mw),&w,&h);

	mw->state->SetInt("Win_X",x);
	mw->state->SetInt("Win_Y",y);
	mw->state->SetInt("Win_W",w);
	mw->state->SetInt("Win_H",h);
}
#endif


static void file_open(GtkAction *action,gpointer *ob)
{
	ProjectGUI *gui=(ProjectGUI *)ob;
	gui->SetStepWidget(0);	// We do this to flush any changes in the current page before loading
	char *fn;
	if(fn=File_Dialog(_("Please choose a GPLin project..."),NULL,gui->window))
	{
		cerr << "Loading " << fn << endl;
		gui->SetFilename(fn);
		gui->Load();
		free(fn);
		gui->SetStepWidget(1);
	}
}


static void file_ppimport(GtkAction *action,gpointer *ob)
{
	ProjectGUI *gui=(ProjectGUI *)ob;
	gui->SetStepWidget(0);	// We do this to flush any changes in the current page before loading
	char *fn;
	if(fn=File_Dialog(_("Please choose a GPLin project..."),NULL,gui->window))
	{
		cerr << "Loading " << fn << endl;
		gui->Import(fn);
		free(fn);
	}
}


//static void file_printersettings(GtkAction *action,gpointer *ob)
//{
//	ProjectGUI *p=(ProjectGUI *)ob;
//	p->PrintSetup();
//}


static void file_quit(GtkAction *action,gpointer *ob)
{
	gtk_main_quit();
}


static GtkActionEntry filemenu_entries[] = {
  { "FileMenu", NULL, N_("_File") },
//  { "NewProject", GTK_STOCK_NEW, N_("New Project..."), "<control>N", N_("Create a new project"), G_CALLBACK(file_new) },
  { "OpenProject", GTK_STOCK_OPEN, N_("_Open Project..."), "<control>O", N_("Open a previously-created project"), G_CALLBACK(file_open) },
//  { "SaveProject", GTK_STOCK_SAVE, N_("_Save Project..."), "<control>S", N_("Save a project"), G_CALLBACK(file_open) },

  { "ImportMenu" , NULL, N_("_Import") },
  { "ImportPPPreset", NULL, N_("_Import PhotoPrint preset..."), NULL, N_("Fetch printer settings from a PhotoPrint preset"), G_CALLBACK(file_ppimport) },
//  { "PrintSetup", NULL, N_("_Print Setup..."), NULL, N_("Adjust printer queue, driver and settings."), G_CALLBACK(file_printersettings) },
  { "Quit", GTK_STOCK_QUIT, N_("_Quit"), "<control>Q", N_("Quit"), G_CALLBACK(file_quit) },
};

static const char *filemenu_ui_description =
"<ui>"
"  <menubar name='MainMenu'>"
"    <menu action='FileMenu'>"
//"      <menuitem action='NewProject'/>"
"      <menuitem action='OpenProject'/>"
//"      <menuitem action='SaveProject'/>"
"      <separator/>"
"      <menu action='ImportMenu'>"
"        <menuitem action='ImportPPPreset'/>"
"      </menu>"
"      <separator/>"
//"      <menuitem action='PrintSetup'/>"
//"      <separator/>"
"      <menuitem action='Quit'/>"
"    </menu>"
"  </menubar>"
"</ui>";


void BuildFileMenu(ProjectGUI *gui,GtkUIManager *ui_manager)
{
	GError *error=NULL;
	GtkActionGroup *action_group;
	action_group = gtk_action_group_new ("FileMenuActions");
	gtk_action_group_set_translation_domain(action_group,PACKAGE);
	gtk_action_group_add_actions (action_group, filemenu_entries, G_N_ELEMENTS (filemenu_entries), gui);
	gtk_ui_manager_insert_action_group (ui_manager, action_group, 0);
	
	if (!gtk_ui_manager_add_ui_from_string (ui_manager, filemenu_ui_description, -1, &error))
		throw error->message;
}

